
	//general functionality
	
$pi = 3.14159;

$RoB2GUI::RateWarn["LOW", text] = "Your average rating given is getting too low. If you continue down-voting, your \"SPAM\" and \"Bad\" options will locked until your average increases.";
$RoB2GUI::RateWarn["LOW", icon] = "255 128 128 255";
$RoB2GUI::RateWarn["LOW", bg] = "255 192 192 255";
$RoB2GUI::RateWarn["DOWN", text] = "Your average rating given is too low, and your negative options have been locked. To unlock them, find the best lots in the city and give them good ratings.";
$RoB2GUI::RateWarn["DOWN", icon] = "255 64 64 255";
$RoB2GUI::RateWarn["DOWN", bg] = "255 128 128 255";
$RoB2GUI::RateWarn["HIGH", text] = "Your average rating given is getting too high. If you continue up-voting, your \"Great\" and \"WIN\" options will locked until your average decreases.";
$RoB2GUI::RateWarn["HIGH", icon] = "128 255 128 255";
$RoB2GUI::RateWarn["HIGH", bg] = "192 255 192 255";
$RoB2GUI::RateWarn["UP", text] = "Your average rating given is too high, and your positive options have been locked. To unlock them, find the worst lots in the city and give them bad ratings.";
$RoB2GUI::RateWarn["UP", icon] = "64 255 64 255";
$RoB2GUI::RateWarn["UP", bg] = "128 255 128 255";
$RoB2GUI::RateWarn["EDGY", text] = "You are giving too many extreme ratings. Not every build is either awesome or terrible; nearly half of your ratings should be \"Poor/Decent/Good\". Be reasonable!";
$RoB2GUI::RateWarn["EDGY", icon] = "255 255 74 255";
$RoB2GUI::RateWarn["EDGY", bg] = "255 255 166 255";
$RoB2GUI::RateWarn["EXTREME", text] = "You have given too many extreme ratings and lost your extreme voting privelidges. To get them back, find typical builds and give them the typical rating they deserve.";
$RoB2GUI::RateWarn["EXTREME", icon] = "255 255 0 255";
$RoB2GUI::RateWarn["EXTREME", bg] = "255 255 90 255";
$RoB2GUI::RateWarn["FEW", text] = "This lot\'s rating is locked at 3 because it has not received enough ratings for a good sample to judge from.";
$RoB2GUI::RateWarn["FEW", icon] = "240 240 240 255";
$RoB2GUI::RateWarn["FEW", bg] = "255 255 255 255";
$RoB2GUI::RateWarn["POOR", text] = "This lot\'s rating is locked at 3 because its owner is still too poor to afford a proper build.";
$RoB2GUI::RateWarn["POOR", icon] = "192 255 255 255";
$RoB2GUI::RateWarn["POOR", bg] = "240 255 255 255";

if(!$RoB2GUIRunning)
{
	$RoB2GUIRunning = true;
	
	exec("./RoB2GUI.gui");
	exec("./RoB2ProdGUI.gui");
	exec("./RoB2StorGUI.gui");
	exec("./RoB2MySaleGUI.gui");
	exec("./RoB2SaleGUI.gui");
	exec("./RoB2OptionsGUI.gui");

	$remapDivision[$remapCount] = "Rise of Blockland 2";
	$remapName[$remapCount] = "Toggle RoB2 GUI";
	$remapCmd[$remapCount] = "toggleRoB2GUI";
	$remapCount++;
	
	new GuiTextCtrl(HUD_gascount) {
	   profile = "BlockChatTextSize3Profile";
	   horizSizing = "right";
	   vertSizing = "bottom";
	   position = (getword(playgui.extent,0) - 301) SPC 14;
	   extent = "110 22";
	   minExtent = "8 2";
	   visible = "0";
	   text = "\c1Gas";
	   maxLength = "255";
	};
	playgui.add(HUD_gascount);
	
	new GUISwatchCtrl(HUD_RoB2Compass) {
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = (getword(playgui.extent,0)-128) SPC (getword(playgui.extent,1)-150);
		extent = "120 120";
		minExtent = "8 2";
		visible = "0";
		color = "0 0 0 0";
	};
	new GuiBitmapCtrl(HUD_RoB2CompassIMG) {
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "19 19";
		extent = "64 64";
		minExtent = "8 2";
		visible = "1";
		bitmap = "./robcompass";
		wrap = "0";
		lockAspectRatio = "0";
		alignLeft = "0";
		overflowImage = "0";
		keepCached = "0";
	};
	new GuiTextCtrl(HUD_RoB2compassN) {
		profile = "BlockChatTextSize3Profile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "320 240";
		extent = "16 22";
		minExtent = "8 2";
		visible = "1";
		text = "\c3N";
		maxLength = "255";
	};
	new GuiTextCtrl(HUD_RoB2compassE) {
		profile = "BlockChatTextSize3Profile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "320 240";
		extent = "16 22";
		minExtent = "8 2";
		visible = "1";
		text = "\c3E";
		maxLength = "255";
	};
	new GuiTextCtrl(HUD_RoB2compassS) {
		profile = "BlockChatTextSize3Profile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "320 240";
		extent = "14 22";
		minExtent = "8 2";
		visible = "1";
		text = "\c3S";
		maxLength = "255";
	};
	new GuiTextCtrl(HUD_RoB2compassW) {
		profile = "BlockChatTextSize3Profile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "320 240";
		extent = "18 22";
		minExtent = "8 2";
		visible = "1";
		text = "\c3W";
		maxLength = "255";
	};
	new GuiTextCtrl(HUD_RoB2compassDot_OP) {
		profile = "BlockChatTextSize10Profile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "320 240";
		extent = "8 36";
		minExtent = "8 2";
		visible = "0";
		text = "\c2.";
		maxLength = "255";
	};
	new GuiTextCtrl(HUD_RoB2compassDot_MyProp) {
		profile = "BlockChatTextSize10Profile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "320 240";
		extent = "8 36";
		minExtent = "8 2";
		visible = "0";
		text = "\c6.";
		maxLength = "255";
	};
	//new GuiBitmapCtrl(RoB2RateYouArrow) {
	//	profile = "GuiDefaultProfile";
	//	horizSizing = "right";
	//	vertSizing = "bottom";
	//	position = "376 124";
	//	extent = "34 27";
	//	minExtent = "8 2";
	//	visible = "0";
	//	bitmap = "./ratearrow";
	//};
	playgui.add(hud_RoB2compass);
	hud_RoB2compass.add(hud_RoB2compassimg);
	hud_RoB2compass.add(hud_RoB2compassn);
	hud_RoB2compass.add(hud_RoB2compasse);
	hud_RoB2compass.add(hud_RoB2compasss);
	hud_RoB2compass.add(hud_RoB2compassw);
	hud_RoB2compass.add(HUD_RoB2compassDot_OP);
	hud_RoB2compass.add(HUD_RoB2compassDot_MyProp);
	//RoB2RatingsSwatch.add(RoB2RateYouArrow);
}

function clientcmdRoB2Ping()
{
	if(isEventPending($RoB2PlaySched)) cancel($RoB2PlaySched);
	$RoB2PlaySched = schedule(500, 0, RoB2GUIPlayUpdate);
	commandtoserver('RoB2Pong');
	RoB2GUILoadOptions();
}



// Main GUI

function toggleRoB2GUI(%val)
{
	if(%val)
	{
		if(RoB2GUI.isAwake()) canvas.popDialog(RoB2GUI);
		else if(RoB2ProdGUI.isAwake() || RoB2StorGUI.isAwake() || RoB2MySaleGUI.isAwake() || RoB2SaleGUI.isAwake()) return;
		else {
			canvas.pushDialog(RoB2GUI);
			RoB2GUI::setPane(%this, $RoB2GUI::pane);
			commandtoserver('RoB2GUIgetPlayerInfo');
			//if(!$RoB2GUI::Checkedversion){
			//	$RoB2GUI::Update = RoB2GUIloadupdate();
			//	commandtoserver('RoB2GUIcheckupdates', $RoB2GUI::Update);
			//	commandtoserver('RoB2GUIcheckversion', $RoB2GUI::Version);
			//} else {
			//	RoB2GUIUpdatesButton.mColor = "255 255 255 255";
			//}
		}	
	}
}

//function RoB2GUIloadupdate(){
//	%file = new FileObject();
//	%file.openforRead("config/RoB2GUI.dat");
//	%update = %file.readline();
//	%file.close();
//	%file.delete();
//	return %update;
//}

function RoB2GUIloadoptions() {
	%file = new FileObject();
	%file.openforRead("config/RoB2GUI.dat");
	%options = %file.readline();
	%file.close();
	%file.delete();
	$RoB2GUI::Options[nocompass] = getsubstr(%options, 0, 1);
	$RoB2GUI::Options[notrackOP] = getsubstr(%options, 1, 1);
	$RoB2GUI::Options[notrackmyprop] = getsubstr(%options, 2, 1);
	RoB2GUI_CBCompass.setvalue(!$RoB2GUI::Options[nocompass]);
	RoB2GUI_CBTrackOP.setvalue(!$RoB2GUI::Options[notrackOP]);
	RoB2GUI_CBTrackMyProp.setvalue(!$RoB2GUI::Options[notrackmyprop]);
	HUD_RoB2compassDot_OP.setVisible(!$RoB2GUI::Options[notrackOP]);
	HUD_RoB2compassDot_MyProp.setVisible(!$RoB2GUI::Options[notrackmyprop]);
}

function RoB2GUISaveOptions() {
	canvas.popDialog(RoB2OptionsGUI);
	$RoB2GUI::Options[nocompass] = !RoB2GUI_CBCompass.getvalue();
	$RoB2GUI::Options[notrackOP] = !RoB2GUI_CBTrackOP.getvalue();
	$RoB2GUI::Options[notrackmyprop] = !RoB2GUI_CBTrackMyProp.getvalue();
	%file = new FileObject();
	%file.openforwrite("config/RoB2GUI.dat");
	%file.writeLine($RoB2GUI::Options[nocompass] @ $RoB2GUI::Options[notrackOP] @ $RoB2GUI::Options[notrackmyprop]);
	%file.close();
	%file.delete();
	HUD_RoB2compassDot_OP.setVisible(!$RoB2GUI::Options[notrackOP]);
	HUD_RoB2compassDot_MyProp.setVisible(!$RoB2GUI::Options[notrackmyprop]);
	//commandtoserver('RoB2GUIOptions', $RoB2GUI::Options[ighelp], $RoB2GUI::Options[showtips]);
}

function RoB2GUI::setPane(%this, %pane)
{
	$RoB2GUI::pane = %pane;
	RoB2NewsHelpSwatch.setVisible(false);
	RoB2PropertySwatch.setVisible(false);
	RoB2RatingsSwatch.setVisible(false);
	switch(%pane)
	{
		
		case 1:
			RoB2PropertySwatch.setVisible(true);
			commandtoserver('RoB2GUIgetPlotInfo');
		case 2:
			RoB2RatingsSwatch.setVisible(true);
			commandtoserver('RoB2GUIgetRatings');
		default:
			RoB2NewsHelpSwatch.setVisible(true);
			RoB2UpdatesButton.mColor = "255 255 255 255";
	}
}

//function clientcmdRoB2GUIcheckedversion()
//{
//	$RoB2GUI::Checkedversion = 1;
//}

function clientcmdRoB2PopAll()
{
	canvas.popDialog(RoB2GUI);
	canvas.popDialog(RoB2ProdGUI);
	canvas.popDialog(RoB2StorGUI);
	canvas.popDialog(RoB2MySaleGUI);
	canvas.popDialog(RoB2SaleGUI);
	//canvas.popDialog(RoB2OptionsGUI);
}

function clientCmdRoB2GUIPop()
{
	canvas.popDialog(RoB2GUI);
}

//function ClientCmdRoB2GUIflashupdate(%update)
//{
//	%file = new FileObject();
//	%file.openforwrite("config/RoB2GUI.dat");
//	%file.writeLine(%update);
	//%file.writeLine($RoB2GUI::Options[nocompass] @ $RoB2GUI::Options[notrackOP] @ $RoB2GUI::Options[notrackmyprop]);
//	%file.close();
//	%file.delete();
//	RoB2GUI.setPane(0);
//	schedule(100,0,"RoB2GUIFlasher", "255 200 0 255");
//	schedule(200,0,"RoB2GUIFlasher", "155 100 0 255");
//	schedule(300,0,"RoB2GUIFlasher", "255 200 0 255");
//	schedule(400,0,"RoB2GUIFlasher", "155 100 0 255");
//	schedule(500,0,"RoB2GUIFlasher", "255 200 0 255");
//	schedule(600,0,"RoB2GUIFlasher", "155 100 0 255");
//	schedule(700,0,"RoB2GUIFlasher", "255 200 0 255");
//	schedule(800,0,"RoB2GUIFlasher", "155 100 0 255");
//	schedule(900,0,"RoB2GUIFlasher", "255 200 0 255");
//}

//function RoB2GUIFlasher(%color)
//{
//	RoB2UpdatesButton.mColor = %color;
//}

function clientcmdRoB2GUIGetInfo(%type, %q, %meter)
{
	echo("GET" SPC %type SPC %q SPC %meter);
	%obj = "RoB2" @ %type;
	if(!isObject(%obj)) return;
	echo("in");
	%obj.setText(%q);
	if(%meter) eval(%obj @ "Meter.extent = (%q + 8) SPC \"26\";");
}


//help tab

function ClientCmdRoB2GUIGetText(%str, %mode){
	//mode: 0 = clear data, 1 = add data, 2 = show data
	switch(%mode){
		case 1:
			$RoB2GUI::GetText = $RoB2GUI::GetText @ %str;
		case 2:
			RoB2NewsHelpText.setText($RoB2GUI::GetText);
		default:
			$RoB2GUI::GetText = "";
	}
}


//property tab
function ClientCmdRoB2GUIGetPropList(%name, %loc, %new)
{
	if(%new) {
		$RoB2GUI::PropListLength = 0;
		RoB2MyPropertiesList.clear();
	}
	RoB2MyPropertiesList.addrow($RoB2GUI::PropListLength, %name, $RoB2GUI::PropListLength);
	$RoB2GUI::PropListLoc[$RoB2GUI::PropListLength] = %loc;
	$RoB2GUI::PropListLength++;
}

function ClientCmdRoB2GUIGetPlotInfo(%plotname, %plotcoords, %plotowner, %plottype, %plotvalue, %buylist, %covers)
{
	RoB2ThisPlotName.setText(%plotname);
	RoB2ThisPlotCoords.setText(%plotcoords);
	RoB2ThisPlotOwner.setText(%plotowner);
	RoB2ThisPlotType.setText(%plottype);
	RoB2ThisPlotValue.setText(%plotvalue);
	RoB2PlotBuyDrop.clear();
	for(%i = 0; getword(%buylist, %i) !$= ""; %i++)
	{
		%text = getword(%buylist, %i);
		%text = strreplace(%text, "_", " ");
		RoB2PlotBuyDrop.add(%text, %i);
	}
	switch(%covers)
	{
		case 1:
			RoB2BuyPlotCover.SetVisible(0);
			RoB2PlotBuyDrop.setText("Buy as...");
			RoB2SellPlotCover.SetVisible(1);
			RoB2RenamePlotCover.SetVisible(1);
		case 2:
			RoB2BuyPlotCover.SetVisible(1);
			RoB2SellPlotCover.SetVisible(0);
			RoB2RenamePlotCover.SetVisible(0);
		default:
			RoB2BuyPlotCover.SetVisible(1);
			RoB2SellPlotCover.SetVisible(1);
			RoB2RenamePlotCover.SetVisible(1);
	}
	RoB2RenameText.setText("");
}

function RoB2MyPropertiesList::Clicked()
{
	%loc = $RoB2GUI::PropListLoc[RoB2MyPropertiesList.getSelectedID()];
	$RoB2GUI::Tracking[myprop, x] = getword(%loc, 0);
	$RoB2GUI::Tracking[myprop, y] = getword(%loc, 1);
	RoB2MyPropertiesList.clearSelection();
}

//function ClientCmdRoB2GUIGetRating(%activeplot, %plotname, %plotowner, %uncover, %myrating, %a, %b, %c, %d, %e)
//{
//	$RoB2ActivePlot = %activeplot;
//	RoB2GUIRateName.setText(%plotname);
//	RoB2GUIRateOwner.setText(%plotowner);
//	if(%uncover) {
//		%pos = 124 + (%myrating * 24);
//		RoB2GUIRateYouArrow.position = "376" SPC %pos;
//		RoB2GUIRateYouArrow.setVisible(true);
//		RoB2GUIRateButtonCover.setVisible(false);
//	} else {
//		RoB2GUIRateYouArrow.setVisible(false);
//		RoB2GUIRateButtonCover.setVisible(true);
//	}
//	RoB2GUIRaffleWinner1.setText(%a);
//	RoB2GUIRaffleWinner2.setText(%b);
//	RoB2GUIRaffleWinner3.setText(%c);
//	RoB2GUIRaffleWinner4.setText(%d);
//	RoB2GUIRaffleWinner5.setText(%e);
//}

//function ClientCmdRoB2GUIGetRatingInfo(%code)
//{
//}

	//Ratings tab
function clientCmdRoB2GUIGetRateInfo(%pa, %pc, %la, %lc, %rating, %tags)
{
	RoB2PlayerPlPot.setvalue(%pa SPC "/" SPC %pc);
	%h = mceil((%pa/%pc) * 329);
	RoB2PlayerPlPotMeter.resize(0, (329-%h), 76, (8+%h));
	RoB2PlayerLotPot.setvalue(%la SPC "/" SPC %lc);
	%h = mceil((%la/%lc) * 329);
	RoB2PlayerLotPotMeter.resize(0, (329-%h), 76, (8+%h));
	switch$(getword(%rating, 0)){
		case "AVG":
			RoB2RatingActualText.setValue("\c6This lot is rated:" SPC getword(%rating, 1));
			RoB2RateCover.setVisible(1);
		case "SELF":
			RoB2RatingActualText.setValue("\c6You have rated this lot:" SPC getword(%rating, 1));
			RoB2RateCover.setVisible(0);
		case "NONE":
			RoB2RatingActualText.setValue("\c6You have not recently rated this lot.");
			RoB2RateCover.setVisible(0);
		default:
			RoB2RatingActualText.setValue("");
			RoB2RateCover.setVisible(1);
	}
	for(%i = 1; %i < 5; %i++) {
		%obj = "RoB2RateWarnSwatch" @ %i;
		%obj.setVisible(0);
	}
	for(%i = 0; %i < GetWordCount(%tags); %i++) {
		%obj = "RoB2RateWarnText" @ (%i+1);
		%obj.setValue($RoB2GUI::RateWarn[getword(%tags, %i), text]);
		%obj = "RoB2RateWarnBG" @ (%i+1); //here we need some gymnastics because setColor on BMP elements doesn't seem to recognize any channel values other than 0 and 255 unless copied from another element. What a crazy bug!
		%icon = "RoB2RateWarnIcon" @ (%i+1);
		%obj.setColor($RoB2GUI::RateWarn[getword(%tags, %i), icon]);
		%icon.setColor(%obj.getColor());
		%obj.setcolor($RoB2GUI::RateWarn[getword(%tags, %i), bg]);
		%obj = "RoB2RateWarnSwatch" @ (%i+1);
		%obj.setVisible(1);
	}
}

	//core production GUI
function ClientCmdRoB2PushProd()
{
	clientcmdRoB2PopAll();
	canvas.pushDialog(RoB2ProdGUI);
}

function ClientCmdRoB2ProdUpdate(%brick, %you, %storage)
{
		RoB2PBrick.setText(%brick);
		RoB2PYou.setText(%you);
		RoB2PStorage.setText(%storage);
		RoB2PMoney.setText(%money);
}


	//storage GUI
function ClientCmdRoB2PushStor()
{
	clientcmdRoB2PopAll();
	canvas.pushDialog(RoB2StorGUI);
}

function ClientCmdRoB2StorUpdate(%storage, %you)
{
	RoB2SStorage.setText(%storage);
	RoB2SYou.setText(%you);
	RoB2SMoveAmt.setText("");
}

	//my sale GUI
function ClientCmdRoB2PushMySale()
{
	clientcmdRoB2PopAll();
	canvas.pushDialog(RoB2MySaleGUI);
}

function ClientCmdRoB2MySaleUpdate(%storage, %selling, %price)
{
	if(%selling) {
		RoB2MSPToggleButton.mColor = "0 192 0 255";
		RoB2MSPToggleButton.setText(strupr("SELLING")); //for some reason this thing won't freakin' display in caps
	} else {
		RoB2MSPToggleButton.mColor = "192 0 0 255";
		RoB2MSPToggleButton.setText("CLOSED");
	}
	RoB2MSPStorage.setText(%storage);
	RoB2MSPPriceAmt.setText(%price);
}



	//sale GUI
function ClientCmdRoB2PushSale()
{
	clientcmdRoB2PopAll();
	canvas.pushDialog(RoB2SaleGUI);
}

function ClientCmdRoB2SaleUpdate(%type, %you, %amt, %price, %max, %color)
{
	switch(%color)
	{
		case 0:
			%c = "\c0";
		case 2:
			%c = "\c2";
		default:
			%c = "\c6";
	}
	%c = "\c6"; //derp
	RoB2SPGoodType.setText(%type);
	RoB2SPYou.setText(%you);
	RoB2SPAmtForSale.setText(%amt);
	RoB2SPPrice.setText(%c @ %price);
	RoB2SPBuyAmt.setText(%max);
}


	//playgui edits
function ClientCMDIsRoB2(%gas)
{
	$PlayingRoB2 = true;
	HUD_gascount.position = (getword(playgui.extent,0) - 301) SPC 14;
	HUD_gascount.setvisible(1);
	HUD_EnergyBar.setvisible(1);
	HUD_gascount.setText("\c1Gas:" SPC (%gas $= "EMPTY" ? %gas : "about " @ %gas));
	if(!iseventpending($RoB2CompassUpdate) && !$RoB2GUI::Options[nocompass]) {
		HUD_RoB2Compass.position = (getword(playgui.extent,0)-128) SPC (getword(playgui.extent,1)-150);
		HUD_RoB2compass.setvisible(1);
		RoB2UpdateCompass();
	}
}

function RoB2UpdateCompass()
{
		if(!isobject(serverconnection.getcontrolobject()) || $RoB2GUI::Options[nocompass]){
			HUD_RoB2compass.setvisible(0);
			return;
		}
		%r=serverconnection.getcontrolobject().gettransform();
		%rx = getword(%r, 0);
		%ry = getword(%r, 1);
		%r=2*$pi-(getword(%r,5)*getword(%r,6));
		%rootcos=mcos(%r);
		%rootsin=msin(%r);
		%compassposx = getword(hud_RoB2compassimg.position, 0) + (getword(hud_RoB2compassimg.extent, 0) / 2);
		%compassposy = getword(hud_RoB2compassimg.position, 1) + (getword(hud_RoB2compassimg.extent, 1) / 2);
		%compassNtxtsizex=16/2;
		%compassNtxtsizey=36/2;
		%compassEtxtsizex=16/2;
		%compassEtxtsizey=36/2;
		%compassStxtsizex=14/2;
		%compassStxtsizey=36/2;
		%compassWtxtsizex=18/2;
		%compassWtxtsizey=36/2;
		hud_RoB2compassN.resize((45 * mcos(%r + $pi * 1.5) + %compassposx ) - %compassNtxtsizex, (45 * msin(%r + $pi * 1.5) + %compassposy) - %compassNtxtsizey, 25, 36);
		hud_RoB2compassE.resize((45 * %rootcos + %compassposx) - %compassEtxtsizex, (45 * %rootsin + %compassposy) - %compassEtxtsizey, 25, 36);
		hud_RoB2compassS.resize((45 * mcos(%r - $pi * 1.5) + %compassposx) - %compassStxtsizex, (45 * msin(%r - $pi * 1.5) + %compassposy) - %compassStxtsizey, 25, 36);
		hud_RoB2compassW.resize((45 * mcos(%r + $pi) + %compassposx) - %compassWtxtsizex, (45 * msin(%r + $pi) + %compassposy) - %compassWtxtsizey, 25, 36);
		if(!$RoB2GUI::Options[notrackOP]) {
			%px = %rx - 16;
			%py = %ry - 16;
			%pdist = msqrt((%py * %py) + (%px * %px));
			HUD_RoB2compassDot_OP.resize((25 * mcos(matan(%py, %px) - %r + $pi) * (-1 * mpow(1.07, (%pdist * -0.2)) + 1) + %compassposx) - 4, (25 * msin(matan(%py, %px) - %r) * (-1 * mpow(1.07, (%pdist * -0.2)) + 1) + %compassposy) - 26, 25, 36);
		}
		if(!$RoB2GUI::Options[notrackmyprop] && $RoB2GUI::Tracking[myprop, x] != 0) {
			%px = %rx - $RoB2GUI::Tracking[myprop, x];
			%py = %ry - $RoB2GUI::Tracking[myprop, y];
			%pdist = msqrt((%py * %py) + (%px * %px));
			HUD_RoB2compassDot_MyProp.resize((25 * mcos(matan(%py, %px) - %r + $pi) * (-1 * mpow(1.07, (%pdist * -0.2)) + 1) + %compassposx) - 4, (25 * msin(matan(%py, %px) - %r) * (-1 * mpow(1.07, (%pdist * -0.2)) + 1) + %compassposy) - 26, 25, 36);

		}
		$RoB2CompassUpdate = schedule(50, 0, RoB2updatecompass);
}

function markspot()
{
	if(!isobject(serverconnection.getcontrolobject())) return;
	$ARBX = getword(serverconnection.getcontrolobject().gettransform(), 0);
	$ARBY = getword(serverconnection.getcontrolobject().gettransform(), 1);
	//messageclient(%client, "", "SPOT MARKED.");
}

function RoB2GUIPlayUpdate()
{
	if(!isobject(serverconnection)) {
		HUD_gascount.setvisible(0);
		if($PlayingRoB2 == true) {
			$PlayerRoB2 = false;
			return; //stops Sched so other servers aren't spammed with a bad cmd
		}
	} else if(!isobject(serverconnection.getcontrolobject())){ //extra IF prevents console errors
		HUD_gascount.setvisible(0);
	} else {
		commandtoserver('IsRoB2');
	}
	$RoB2PlaySched = schedule(500, 0, RoB2GUIPlayUpdate);
}